//+------------------------------------------------------------------+
//|                                                 Limit_Sample.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Trade\Trade.mqh>
#include <Trade\OrderInfo.mqh>
//---     
CTrade  trade;
COrderInfo order;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---  
   trade.SetDeviationInPoints(10);
   trade.LogLevel(LOG_LEVEL_ALL);
   trade.SetAsyncMode(false);
   trade.SetTypeFilling(ORDER_FILLING_RETURN);
//---
   BuyLimit_Sample();
//---
   ulong ticket=OrderExists();
   Sleep(25);
   ModifyOrder(ticket);
//---
   Sleep(25);
   DeleteOrder(ticket);
//---
  }
//+------------------------------------------------------------------+
//|                  |
//+------------------------------------------------------------------+
void BuyLimit_Sample()
  {
//--- 2.     BuyLimit   
   double volume=1;
   string symbol="Si-6.16";                                    //  ,    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS); //    
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);         // 
   double ask=SymbolInfoDouble(symbol,SYMBOL_ASK);             //   
   double price=ask-100*point;                                 //   
   price=NormalizeDouble(price,digits);                        //   
   int SL_pips=100;                                            // Stop Loss  
   int TP_pips=100;                                            // Take Profit  
   double SL=price-SL_pips*point;                              //   SL
   SL=NormalizeDouble(SL,digits);                              //  Stop Loss
   double TP=price+TP_pips*point;                              //   TP
   TP=NormalizeDouble(TP,digits);                              //  Take Profit
   datetime expiration=TimeTradeServer()+PeriodSeconds(PERIOD_D1);
   string comment=StringFormat("Buy Limit %s %G lots at %s, SL=%s TP=%s",
                               symbol,volume,
                               DoubleToString(price,digits),
                               DoubleToString(SL,digits),
                               DoubleToString(TP,digits));
//---  ,      Buy Limit
   if(!trade.BuyLimit(volume,price,symbol,SL,TP,ORDER_TIME_DAY,expiration,comment))
     {
      //---   
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" BuyLimit()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---   
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void ModifyOrder(ulong ticket)
  {
//---     
   if(!OrderSelect(ticket))
     {
      Print(" #",ticket,"  ");
      return;
     }
//---     ,   
   string symbol=OrderGetString(ORDER_SYMBOL);
//---    
   int    digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
//---  
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
//---   
   double price=OrderGetDouble(ORDER_PRICE_OPEN);
//---     SL  TP
   double SL=NormalizeDouble(price-200*point,digits);
   double TP=NormalizeDouble(price+200*point,digits);
//---  ,     
//   if(!trade.OrderModify(ticket,price,SL,TP,(ENUM_ORDER_TYPE_TIME)OrderGetInteger(ORDER_TYPE_TIME),0))

   if(!trade.OrderModify(ticket,price,SL,TP,ORDER_TIME_DAY,0))
     {
      //---   
      Print(" OrderModify()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" OrderModify()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
void DeleteOrder(ulong ticket)
  {
//---     
   if(!OrderSelect(ticket))
     {
      Print(" #",ticket,"  ");
      return;
     }
//---  ,    
   if(!trade.OrderDelete(ticket))
     {
      //---   
      Print(" OrderDelete()  .  =",trade.ResultRetcode(),
            ".  : ",trade.ResultRetcodeDescription());
     }
   else
     {
      Print(" OrderDelete()  .  =",trade.ResultRetcode(),
            " (",trade.ResultRetcodeDescription(),")");
     }
//---     
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
ulong OrderExists()
  {
   for(int i=0;i<OrdersTotal();i++)
     {
      if(order.SelectByIndex(i))
        {
         if(order.Symbol()==_Symbol)
           {
            return order.Ticket();
           }
        }
     }
   return 0;
  }
//+------------------------------------------------------------------+,  
